/*****************************************
 *  @f[^K[
 * @SHT35{SDCard{LCD
 *****************************************/
#include "mcc_generated_files/mcc.h"
#include "lcd8x2_lib.h"
#include <string.h>
// ϐ`
uint8_t Flag, logFlag, logStart, upInterval, upFlag, logInterval; 
uint8_t Line1[9], Line2[9], logdata[20], State;
double Data[2];
uint16_t Time, Length;
// Ambientpϐ
char Body[] =  "\"32.1\",\"d2\":\"45.6\"}\r\n";
char DataByte[5], data[54];
// File Systme@ϐ
FRESULT result;
FATFS drive;
FIL file;
// Xe[gϐ`
enum TaskState{
    WAIT_SW,
    MOUNT,
    W_OPEN,
    SD_WRITE,
    fCLOSE,
    ALL_END,
};
// ֐vg^Cv
void SensorConfig(void);
void GetSensor(double * data);
bool getResponse(char *word, uint16_t timeout);
void SendStr(char * Buf);
/***********************
 * ^C}0 Calback֐
 **********************/
void TMR0_Process(void){
    Flag = 1;
    logInterval--;
    // O`FbN
    if(logInterval == 0){
        logInterval = 5;        // 10b
        logFlag = 1;
    }
    // Abv[h`FbN
    upInterval--;
    if(upInterval == 0){
        upInterval = 30;        // 1
        upFlag = 1;
    }
}
/***** C֐ ****************/
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(TMR0_Process);
    lcd_init();                 // LCD
    State = MOUNT;
    logStart = 0;
    upInterval = 30;            // 1min
    logInterval = 5;            // 10sec
    // 荞݋
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    /***** C[v **************/
    while (1)
    {
        if(Flag == 1){
            Flag = 0;
            D2_Toggle();
            /******** vLCD\ **************/
            // xZTf[^擾
            SensorConfig();                 // ZTݒ
            GetSensor(Data);                // ZTf[^ǂݏo 
            sprintf(Line1, "T=%2.1f %c", Data[0], 0xDF);
            sprintf(Line2, "H=%2.1f %%", Data[1]);
            // LCD\
            lcd_cmd(0x80);                  // 1s
            lcd_str(Line1);
            lcd_cmd(0xC0);                  // 2s
            lcd_str(Line2);
        }
        /******** Ambient Upload *******************/
        if(upFlag == 1){
            D4_SetHigh();
            upFlag = 0;
            // Bodyf[^
            sprintf(Body, "\"%02.1f\",\"d2\":\"%2.1f\"}\r\n", Data[0], Data[1]);
            /***ANZX|CgƐڑ@****/
            // ESP Initialize
            SendStr("AT+CWMODE=1\r\n");                  // Xe[V[h 
            getResponse("OK", 1);     
            do{
                SendStr("AT+CWJAP=\"---SSID---\",\"---Password--\"\r\n");
                __delay_ms(1000);
            }while(getResponse("GOT IP", 5)==false);   // GOT IPԂ܂ŌJԂ              
            /** AmbientT[oƐڑ **/
            do{            
                SendStr("AT+CIPSTART=\"TCP\",\"54.65.206.59\",80\r\n"); 
                __delay_ms(1000);
            }while(getResponse("CONNECT", 5)==false);   // CONNECTɂȂ܂ŌJԂ            
            // TCPAmbientPOSTM
            SendStr("AT+CIPSEND=174\r\n");              // M                                       
            getResponse(">", 3);                        // OK >҂ 
            SendStr("POST /api/v2/channels/CHID/data HTTP/1.1\r\n");
            SendStr("Host: 54.65.206.59\r\n");
            SendStr("Content-Length: 57\r\n");
            SendStr("Content-Type: application/json\r\n\r\n");
            // BodyM
            SendStr("{\"writeKey\":\"--WriteKey--\",\"d1\":");
            SendStr(Body);                               // M  
            getResponse("SEND OK", 3);                  // SEND OK҂
            // Ambient̉҂
            getResponse("200 OK", 5);                   // HTTP/1.1 200 OK҂             
            getResponse("CLOSED", 3);                   // CLOSED҂             
            __delay_ms(500);
            SendStr("AT+CWQAP\r\n");                     // APƂ̐ڑ
            getResponse("OK", 3);
            D4_SetLow();           
        }    
        /******* SD Cardɕۑ ***************/        
        // OJn`FbN
        if(S1_GetValue() == 0){  
            // J[h}Eg
            while(f_mount(&drive,"0:",1) != FR_OK){     // }Egł܂                
                D5_Toggle();                            // ڈ 
                __delay_ms(200);                        // x
                lcd_str("No Mount");
            }
            D5_SetLow();
            // t@CI[v@ǋL̏݃[h
            if(f_open(&file, "THLogger.TXT",  FA_WRITE | FA_OPEN_APPEND) == FR_OK){         
                logStart = 1;                           // OJn
                Time = 0;
            }
        }
        // SDJ[hݏ
        if((logStart == 1) && (logFlag == 1)){          // OJn̏ꍇ
            Time++;
            logFlag = 0;
            sprintf(logdata, "%06d,%+2.1f,%3.1f\r\n", Time, Data[0], Data[1]);
            D3_Toggle();                        // ڈ
            // f[^ݎs@̍Ō0x00
            f_write(&file, logdata, sizeof(logdata)-1, Length); 
        }
        // OI`FbN
        if(S2_GetValue() == 0){
            logStart = 0;                               // OI
            f_close(&file);                             // t@CN[Y                    
            f_mount(0, "0:", 0);                        // A}Eg
        }
    }            
}
/*********************************
* ZTݒo
*********************************/
void SensorConfig(void){
    uint8_t tbuf[2];                    // obt@\
    
    tbuf[0] = 0x2C;                     // f[^w
    tbuf[1] = 0x06;;                    // f[^
    while(!I2C2_Open(0x45));            // oX擾
    I2C2_SetBuffer(tbuf,2);             // obt@p
    I2C2_MasterWrite();                 // ݎs
    while(I2C2_BUSY == I2C2_Close());   // ʐMI҂
}
/*******************************
 *  ZTf[^ǂݏo
 *******************************/
void GetSensor(double * data){
    uint8_t tbuf[6];
    double temp;
    
    while(!I2C2_Open(0x45));            // oX擾
    I2C2_SetBuffer(tbuf,6);             // obt@p
    I2C2_MasterRead();                  // ǂݏos
    while(I2C2_BUSY == I2C2_Close());   // ʐMI҂
    // f[^ϊƖ߂li[
    temp = tbuf[0]*256.0 + tbuf[1];     // x
    *data++ = (temp*175.0)/65535 - 45; 
    temp = tbuf[3]*256.0 + tbuf[4];     // x
    *data = (temp*100.0)/65535;
}
/***********************************
 * 񑗐M֐
 ***********************************/
void SendStr(char * Buf){
    char* ptr;
    
    ptr = Buf;                  // |C^l
    while(*ptr != 0){           // 0łȂꍇ
        EUSART_Write(*ptr);     // oM
        ptr++;                  // |C^XV
    }
}
/************************************************
 *  ESPR}h҂
 * @^C}PŃ^CAEgo
 *@ Timer1 31kHz/8=3875 -> 1sec @Max 16sec
 ************************************************/
bool getResponse(char *word, uint16_t timeout){
    char a, flag;
    uint16_t j;
    
    j = 0;                                      // CfbNXZbg    
    flag = 0;                                   // 񔭌tOZbg
    TMR1_WriteTimer(0xFFFF-timeout*3874);       // ^C}bZbg
    TMR1_StartTimer();                          // ^C}PX^[g
    PIR4bits.TMR1IF = 0;                        // ^C}tOZbg    
    /** Ms ****/
    while(PIR4bits.TMR1IF == 0){                // ^CAbv܂ŌJԂ
        while(EUSART_is_rx_ready() == true){    // Mf[^̏ꍇ
            a = (char)EUSART_Read();            // Mf[^擾
            if(a == '\0') continue;             // 0x00͏Ȃ
            data[j] = a;                        // Mobt@ɒǉ
            if(j<52)                            // 52ȏ͖
                j++;                            // ̃obt@
            data[j] = 0;                        // ĨtO
        }
        // Mf[^
        if(( a == '\n')||(a == '>')){           // I肩̏ꍇ
            if(strstr(data, word) != 0){        // 񌟍
                flag = 1;                       // 񔭌tOI
                TMR1_StopTimer();               // ^C}1~
                break;                          // I
            }
            j = 0;                              // obt@̍ŏɖ߂
        }
    }
    // ߂lZbg
    if(flag == 1)
        return true;                            // 񂪌ꍇ
    else
        return false;                           // ^CAbv̏ꍇ      
}